#include "io430.h"
#include "ir_receiver.h"
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

void command(volatile unsigned char number, volatile unsigned char lags[]);

int main(void)
{
  // Bei anderen Fernbedienungen unterscheiden sich die Pulse
  // vielleicht schon vor dem 16ten!
  initialize(16, command);

  puts("Ziffer drcken:\n0");
  
  while(true)
  {}
  
  //return 0;
}

/*

void command(volatile unsigned char number, volatile unsigned char lags[])
{
  if(number == 0)
  {
    puts("zu wenig Pulse\n");
  }
  else
  {
    for(int i = 0; i < number; i++)
    {
      write(lags[i]);
    }
    putchar('\n');
  }
}

*/

void command(volatile unsigned char number, volatile unsigned char lags[])
{  
  static int step = 0;

  // Hack: static const int wre schner,
  // klappt als Arraygre aber nur mit VLA
  enum {keysToLearn = 5};
  static unsigned char learnedLags[keysToLearn][maximumNumberOfLags] = {0};
  
  static unsigned int currentResult = 0;
  static unsigned int currentOperand = 0;
  
  if(step < keysToLearn)
  {
    for(int i = 0; i < number; i++)
    { 
      learnedLags[step][i] = lags[i];
    }
    
    if(step < keysToLearn - 2)
    {
      puts("Ziffer drcken:");
      write(step + 1);
    }
    else if(step == keysToLearn - 2)
    {
      puts("OK-Taste drcken.");
    }
    else
    {
      puts("Lernen beendet.");
    }
    
    step++;
  }
  else
  {
    // Welche Taste wurde gedrckt?
    int minIndex = -1;
    unsigned int minDistance = 0xFFFF;
    for(int i = 0; i < keysToLearn; i++)
    {
      unsigned int sum = 0;
      for(int j = 0; j < maximumNumberOfLags; j++)
      {
        sum += abs((int)lags[j] - (int)learnedLags[i][j]);
      }
      if(sum < minDistance)
      {
        minDistance = sum;
        minIndex = i;
      }
    }
    
    if(minIndex < keysToLearn - 1) // war eine Zifferntaste
    {
      currentOperand *= 10;
      currentOperand += minIndex;
      write(currentOperand);
    }
    else // war die OK-Taste
    {
      currentResult += currentOperand;
      puts("Summe:");
      write(currentResult);
      currentOperand = 0;
    }
  }
}